#ifndef BLC_ARRAY_TCP4_CLIENT_H
#define BLC_ARRAY_TCP4_CLIENT_H

#include"blc_array_network.h"

#ifdef __cplusplus
#include <string>
#include <vector>
#endif

typedef struct blc_array_tcp4_client
#ifdef __cplusplus
:blc_array_network {
    blc_array_tcp4_client(std::string const &address, std::string const &port_name);
    blc_array_tcp4_client(std::string const &address, std::string const &port_name, uint32_t type, uint32_t format, std::vector<size_t> const &lengths);

    void read_properties();
 //   void server_manager();
    int recv_data();
    int bytes_to_read();
    void send_data();
#else
{   blc_array array;// Not beautiful but makes it easy to convert C++ heritage of "class"  in C struct inclusion.
#endif
}blc_array_tcp4_client;

START_EXTERN_C
blc_array_tcp4_client *blc_array_tcp4_client_new_void(const char *address, const char* port);
blc_array_tcp4_client *blc_array_tcp4_client_new( char const *address, char const *port_name, uint32_t type, uint32_t format, int dims_nb, size_t length0, ...);

void blc_array_tcp4_client_send_data(blc_array_tcp4_client *client);
int blc_array_tcp4_client_recv_data(blc_array_tcp4_client *client);
int blc_array_tcp4_client_bytes_to_read(blc_array_tcp4_client *client);

void blc_array_tcp4_client_delete(blc_array_tcp4_client *client);
END_EXTERN_C


#endif // BLC_ARRAY_TCP4_CLIENT_H
