#ifndef BLC_ARRAY_TCP4_SERVER_HPP
#define BLC_ARRAY_TCP4_SERVER_HPP

#include"blc_array_network.h"
#include <string>
#include <thread>

typedef struct blc_array_tcp4_server
#ifdef __cplusplus
:blc_array_network {
    blc_array_tcp4_server(std::string const &port_name);
    blc_array_tcp4_server(std::string const &port_name, uint32_t type, uint32_t format, std::vector<size_t> const &lengths);
    
    void read_properties();
    void send_properties();
    int recv_data();
    int send_data();
    void server_manager();
    int wait_connection();
#else
    blc_array  *array;
#endif
    int client_socket; //We suppose only on client
}blc_array_tcp4_server;

START_EXTERN_C
blc_array_tcp4_server *blc_array_tcp4_server_new_void(char const *port_name);
blc_array_tcp4_server *blc_array_tcp4_server_new(char const *port_name, uint32_t type, uint32_t format, int dims_nb, size_t length0, ...);
int blc_array_tcp4_server_wait_connection(blc_array_tcp4_server *server);
void blc_array_tcp4_server_delete(blc_array_tcp4_server *server);
END_EXTERN_C

/*
    void blc_array_tcp4_server_thread(blc_array *array, string const &port_name){
}*/

#endif // BLC_ARRAY_TCP4_SERVER_HPP
